package com.vendor.platform.core;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.platform.core.PlatformCoreActivator;
import java.util.ArrayList;
import java.util.Dictionary;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.eclipse.core.runtime.Platform;
import org.eclipse.equinox.p2.metadata.IInstallableUnit;
import org.osgi.framework.Bundle;

public class ToolDescriptor {
  public IInstallableUnit iu;
  
  public ToolProperties props;
  
  private List<PluginDetail> plugins;
  
  public ToolDescriptor(IInstallableUnit iu) {
    this.iu = iu;
    this
      .props = new ToolProperties(PlatformCoreActivator.getDefault().getToolManager().getToolInfo(iu));
  }
  
  public IInstallableUnit getInstallableUnit() {
    return this.iu;
  }
  
  public String getId() {
    return this.props.getId();
  }
  
  public String getVersion() {
    return this.props.getVersion();
  }
  
  public String getName() {
    return this.props.getName();
  }
  
  public Map<String, String> getProperties() {
    return this.iu.getProperties();
  }
  
  public String[] getPluginIds() {
    List<PluginDetail> list = getPlugins();
    String[] pluginIds = new String[list.size()];
    for (int i = 0; i < pluginIds.length; i++)
      pluginIds[i] = ((PluginDetail)list.get(i)).getPluginId(); 
    return pluginIds;
  }
  
  public List<PluginDetail> getPlugins() {
    if (this.plugins == null) {
      Set<String> list = PlatformCoreActivator.getDefault().getToolManager().getToolPlugins(this.iu);
      this.plugins = new ArrayList<>();
      for (String id : list) {
        String name = null;
        String providerName = null;
        String version = null;
        PluginDetail p = new PluginDetail();
        p.setPluginId(id);
        Bundle bundle = Platform.getBundle(id);
        try {
          if (bundle != null) {
            Dictionary<String, String> headers = bundle.getHeaders();
            name = (headers.get("Bundle-Name") == null) ? "" : headers.get("Bundle-Name");
            providerName = (headers.get("Bundle-Vendor") == null) ? "" : headers.get("Bundle-Vendor");
            version = (headers.get("Bundle-Version") == null) ? "" : headers.get("Bundle-Version");
          } 
        } catch (Exception exception) {}
        p.setPluginName(name);
        p.setVersion(version);
        p.setProvider(providerName);
        this.plugins.add(p);
      } 
    } 
    return this.plugins;
  }
}
